#ifndef _HOPF_H_
#define _HOPF_H_

/******************************************************************************
 *
 * Frank Haverkamp 1999
 * haver@ibr.cs.tu-bs.de
 *
 * $Id: $
 *
 * $Log: $
 *
 *****************************************************************************/

/*
 * Split minors in two parts
 */
#define TYPE(dev)   (MINOR(dev) >> 4)   /* high nibble */
#define NUM(dev)    (MINOR(dev) & 0xf)  /* low  nibble */

#define VERSION              "0.1b"
#define AUTHOR               "Frank Haverkamp & Sven Bauhan & Holger Jakob"
#define DEV_NAME             "hopf6036"
#define HOPF_MAJOR        241
#define PORT_ADDRESS    0x280
#define SECTION_BEGIN   0x200
#define SECTION_END     0x3C0
#define PORT_SIZE        0x40
#define MEZ_OFFSET       0x08
#define UTC_OFFSET       0x18
#define MSEC_OFFSET      0x38
#define SET_OFFSET       0x30
#define COMMAND_OFFSET   0x37
#define KENNUNGS_OFFSET  0x3B
#define GUETE_OFFSET     0x3D

/******************************************************************************
 *
 * The  following  macros  are defined in the <linux/kernel.h> header file.
 * They can be used to determine the priority level of the screen outputs of
 * the driver.
 *
 *    KERN_EMERG     System is unuseable
 *    KERN_ALERT     Action must be taken immediately
 *    KERN_CRIT      Critical conditions
 *    KERN_ERR       Error conditions
 *    KERN_WARNING   Warning conditions
 *    KERN_NOTICE    Normal but significant condition
 *    KERN_INFO      Informational
 *    KERN_DEBUG     Debug-level messages
 *
 * The Symbol DEBUG can be set in the Makefile of the driver. If you compile
 * it with make DEBUG=y the DPRINTK-function is acivated. If not it is disabled
 * and driver outputs are only made in case of errors.
 * Use this definitions to print out messages. You can change the priorities
 * in this definitions according to the supported macros above.
 *
 *****************************************************************************/

#ifdef DEBUG
#define DPRINTK(format, args...) printk(KERN_INFO DEV_NAME": " format , ## args)
#else
#define DPRINTK(format, args...)
#endif
#define PERRORK(format, args...) printk(KERN_ERR DEV_NAME": " format , ## args)
#define PINFOK(format, args...)  printk(KERN_INFO DEV_NAME": " format , ## args)

typedef struct HOPF {
  int port;
  /* ... */
} HOPF;
typedef struct ClockVersion {
	char cVersion[255];
	char dVersion[255];
} ClockVersion;


//unsigned long int hopf_test ();

#endif
