#ifndef _HOPFIOCTL_H_
#define _HOPFIOCTL_H_

/******************************************************************************
 *
 * Frank Haverkamp 1999
 * haver@ibr.cs.tu-bs.de
 *
 * $Id: $
 *
 * $Log: $
 *
 *****************************************************************************/

/******************************************************************************
 *
 * Frank Haverkamp 1999
 * haver@ibr.cs.tu-bs.de
 *
 * $Id: $
 *
 * $Log: $
 *
 *****************************************************************************/

#include <asm/ioctl.h>
#include <linux/types.h>

#define HOPF_TIMESIZE 8
typedef unsigned char hopf_time_t[HOPF_TIMESIZE];

/* 
 * represents the data size wich is transfered in ioctl calls. 
 * don't use sizeof(item), because sizeof is part of the macro expansion.
 * use 'm' as magic number of the device 
 */
#define HOPF_IOC_MAGIC   'h'
#define HOPF_IOCS_RESET  _IO  (HOPF_IOC_MAGIC, 1)  /* debugging tool */
#define HOPF_IOCG_STATUS _IOR (HOPF_IOC_MAGIC, 2, unsigned char)  /* getting status info */
#define HOPF_IOCG_TIME   _IOR (HOPF_IOC_MAGIC, 3, hopf_time_t)
#define HOPF_IOCS_SET    _IOW (HOPF_IOC_MAGIC, 4, hopf_time_t)
#define HOPF_IOCS_PORT   _IOW (HOPF_IOC_MAGIC, 5, unsigned long)
#define HOPF_IOCQ_PORT   _IO  (HOPF_IOC_MAGIC, 6)
#define HOPF_IOCQ_GUETE  _IO  (HOPF_IOC_MAGIC, 7)
#define HOPF_IOCS_SLAVE  _IO  (HOPF_IOC_MAGIC, 8)
#define HOPF_IOCS_MASTER _IO  (HOPF_IOC_MAGIC, 9)
#define HOPF_IOC_MAXNR 9


#define HOPF_CLOCK_CMD_MASK 0xff000

#define HOPF_CLOCK_GET_LOCAL        0x10000
#define HOPF_CLOCK_GET_UTC          0x20000
#define HOPF_CLOCK_GET_ANTENNA      0x30000
#define HOPF_CLOCK_GET_DIFFERENCE   0x40000
#define HOPF_CLOCK_GET_VERSION      0x50000
#define HOPF_CLOCK_GET_POSITION     0x60000
#define HOPF_CLOCK_GET_SATDATA      0x70000
#define HOPF_CLOCK_GET_SYSTEMBYTE   0x80000
#define HOPF_CLOCK_GET_IRIG         0x90000

#define HOPF_CLOCK_SET_DIFFERENCE   0x01000
#define HOPF_CLOCK_SET_ANTENNA      0x02000
#define HOPF_CLOCK_SET_TIME         0x03000
#define HOPF_CLOCK_SET_POSITION     0x04000
#define HOPF_CLOCK_SET_SATMODE      0x05000
#define HOPF_CLOCK_SET_SYSTEMBYTE   0x06000
#define HOPF_CLOCK_SET_RESET        0x07000
#define HOPF_CLOCK_SET_IRIG         0x08000

// clock command codes

#define HOPF_CLOCK_HARDRESET        0x00008000
#define HOPF_CLOCK_SOFTRESET        0x00004000

typedef struct HOPFTIME { 
    unsigned int wYear; 
    unsigned int wMonth; 
    unsigned int wDayOfWeek; 
    unsigned int wDay; 
    unsigned int wHour; 
    unsigned int wMinute; 
    unsigned int wSecond; 
    unsigned int wMilliseconds;
    unsigned int wStatus; 
} HOPFTIME;


#endif
